--
-- SetAnimationEvent
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history		v1.0 - 2015-06-24 - Initial implementation
-- 

SetAnimationEvent = {};
SetAnimationEvent_mt = Class(SetAnimationEvent, Event);

InitEventClass(SetAnimationEvent, "SetAnimationEvent");

function SetAnimationEvent:emptyNew()
    local self = Event:new(SetAnimationEvent_mt);
    self.className = "SetAnimationEvent";
	
    return self;
end;

function SetAnimationEvent:new(object, animationIndex, isActivated)
    local self = SetAnimationEvent:emptyNew()
    self.object = object;
	self.animationIndex = animationIndex;
	self.isActivated = isActivated;
	
    return self;
end;

function SetAnimationEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.animationIndex = streamReadInt32(streamId);
	self.isActivated = streamReadBool(streamId);
	
    self:run(connection);
end;

function SetAnimationEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt32(streamId, self.animationIndex);
	streamWriteBool(streamId, self.isActivated);
end;

function SetAnimationEvent:run(connection)
	self.object:setAnimationClip(self.animationIndex, self.isActivated, true)
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetAnimationEvent:new(self.object, self.animationIndex, self.isActivated), nil, connection, self.object);
	end;
end;

function SetAnimationEvent.sendEvent(vehicle, animationIndex, isActivated, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetAnimationEvent:new(vehicle, animationIndex, isActivated), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetAnimationEvent:new(vehicle, animationIndex, isActivated));
		end;
	end;
end;