--
-- SetInActiveStateEvent
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history		v1.0 - 2015-10-03 - Initial implementation
-- 

SetInActiveStateEvent = {};
SetInActiveStateEvent_mt = Class(SetInActiveStateEvent, Event);

InitEventClass(SetInActiveStateEvent, "SetInActiveStateEvent");

function SetInActiveStateEvent:emptyNew()
    local self = Event:new(SetInActiveStateEvent_mt);
    self.className = "SetInActiveStateEvent";
	
    return self;
end;

function SetInActiveStateEvent:new(object, InActiveState)
    local self = SetInActiveStateEvent:emptyNew()
    self.object = object;
	self.InActiveState = InActiveState;
	
    return self;
end;

function SetInActiveStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.InActiveState = streamReadBool(streamId);
	
    self:run(connection);
end;

function SetInActiveStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.InActiveState);
end;

function SetInActiveStateEvent:run(connection)
	self.object:setInActiveState(self.InActiveState, true);
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetInActiveStateEvent:new(self.object, self.InActiveState), nil, connection, self.object);
	end;
end;

function SetInActiveStateEvent.sendEvent(object, InActiveState, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetInActiveStateEvent:new(object, InActiveState), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(SetInActiveStateEvent:new(object, InActiveState));
		end;
	end;
end;