if not Utils.joinFix20150920 then
	Utils.joinFix20150920 = true;
	Utils.playerJoinEventsToSend = {};
	
	local Server_sendObjects_old = Server.sendObjects;
	function Server:sendObjects(connection, x, y, z, viewDistanceCoeff)
		connection:sendEvent(SynchObjectListEvent:new());
		
		for _, class in ipairs(Utils.playerJoinEventsToSend) do
			connection:sendEvent(class:new());
		end;
		
		Server_sendObjects_old(self, connection, x, y, z, viewDistanceCoeff);
	end;
end;

--
-- SynchObjectListEvent
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history		v1.0 - 2015-09-20 - Initial implementation
-- 

SynchObjectListEvent = {};
SynchObjectListEvent_mt = Class(SynchObjectListEvent, Event);

SynchObjectListEvent.AVAILABLE = 1;
SynchObjectListEvent.BOUGHT = 2;

InitEventClass(SynchObjectListEvent, "SynchObjectListEvent");
table.insert(Utils.playerJoinEventsToSend, SynchObjectListEvent);

function SynchObjectListEvent:emptyNew()
    local self = Event:new(SynchObjectListEvent_mt);
	
    self.className = "SynchObjectListEvent";
	
    return self;
end;

function SynchObjectListEvent:new()
	local self = SynchObjectListEvent:emptyNew();
	
    return self;
end;

function SynchObjectListEvent:readStream(streamId, connection)
	if connection:getIsServer() then
		local numParents = streamReadInt16(streamId);
		
		for i = 1, numParents do
			local modName = streamReadString(streamId);
			local numObjects = streamReadInt16(streamId);
			
			for k = 1, numObjects do
				local id = streamReadInt16(streamId);
				local available = streamReadInt16(streamId);
				local bought = streamReadInt16(streamId);
				
				g_currentMission.HardPoint:updateListObject(SynchObjectListEvent.AVAILABLE, modName, id, available, true);
				g_currentMission.HardPoint:updateListObject(SynchObjectListEvent.BOUGHT, modName, id, bought, true);
			end;
		end;
	end;
end;

function SynchObjectListEvent:writeStream(streamId, connection)
	if not connection:getIsServer() then
		local numParents = 0;
		local numObjects = {};
		
		for modName, v in pairs(g_currentMission.HardPoint.objectStats) do
			numParents = numParents + 1;
			
			for _ in pairs(v.object) do
				if numObjects[modName] == nil then
					numObjects[modName] = 0;
				end;
				
				numObjects[modName] = numObjects[modName] + 1;
			end;
		end;
		
		streamWriteInt16(streamId, numParents);
		
		for modName, v in pairs(g_currentMission.HardPoint.objectStats) do
			streamWriteString(streamId, modName);
			streamWriteInt16(streamId, numObjects[modName]);
			
			for id, o in pairs(v.object) do
				streamWriteInt16(streamId, id);
				streamWriteInt16(streamId, o.available);
				streamWriteInt16(streamId, o.bought);
			end;
		end;
	end;
end;

function SynchObjectListEvent:run(connection)
end;