--
-- buyAndSellObjectEvent
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history		v1.0 - 2014-03-30 - Initial implementation
-- 

buyAndSellObjectEvent = {};
buyAndSellObjectEvent_mt = Class(buyAndSellObjectEvent, Event);

InitEventClass(buyAndSellObjectEvent, "buyAndSellObjectEvent");

function buyAndSellObjectEvent:emptyNew()
    local self = Event:new(buyAndSellObjectEvent_mt);
    self.className = "buyAndSellObjectEvent";
	
    return self;
end;

function buyAndSellObjectEvent:new(isBuying, price)
    local self = buyAndSellObjectEvent:emptyNew()
    self.isBuying = isBuying;
    self.price = price;
	
    return self;
end;

function buyAndSellObjectEvent:readStream(streamId, connection)
    if not connection:getIsServer() then
		self.isBuying = streamReadBool(streamId);
		self.price = streamReadFloat32(streamId);
	end;
	
    self:run(connection);
end;

function buyAndSellObjectEvent:writeStream(streamId, connection)
    if connection:getIsServer() then
		streamWriteBool(streamId, self.isBuying);
		streamWriteFloat32(streamId, self.price);
	end;
end;

function buyAndSellObjectEvent:run(connection)
	if not connection:getIsServer() then
		if self.isBuying then
			g_currentMission:addMoney(-self.price, g_currentMission:findUserIdByConnection(connection), "other");
		else
			g_currentMission:addMoney(self.price, g_currentMission:findUserIdByConnection(connection), "other");
		end;
	end;
end;