--
-- updateListObjectEvent
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history		v1.0 - 2014-03-30 - Initial implementation
-- 

updateListObjectEvent = {};
updateListObjectEvent_mt = Class(updateListObjectEvent, Event);

InitEventClass(updateListObjectEvent, "updateListObjectEvent");

function updateListObjectEvent:emptyNew()
    local self = Event:new(updateListObjectEvent_mt);
	
    self.className = "updateListObjectEvent";
	
    return self;
end;

function updateListObjectEvent:new(type, modName, objectId, newValue)
    local self = updateListObjectEvent:emptyNew();
	
    self.type = type;
	self.modName = modName;
	self.objectId = objectId;
	self.newValue = newValue;
	
    return self;
end;

function updateListObjectEvent:readStream(streamId, connection)
	self.type = streamReadInt8(streamId);
	self.modName = streamReadString(streamId);
	self.objectId = streamReadInt8(streamId);
	self.newValue = streamReadInt8(streamId);
		
    self:run(connection);
end;

function updateListObjectEvent:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.type);
	streamWriteString(streamId, self.modName);
	streamWriteInt8(streamId, self.objectId);
	streamWriteInt8(streamId, self.newValue);
end;

function updateListObjectEvent:run(connection)
	g_currentMission.HardPoint:updateListObject(self.type, self.modName, self.objectId, self.newValue, true);
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(updateListObjectEvent:new(self.type, self.modName, self.objectId, self.newValue), nil, connection, g_currentMission.HardPoint);
	end;
end;

function updateListObjectEvent.sendEvent(type, modName, objectId, newValue, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(updateListObjectEvent:new(type, modName, objectId, newValue), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(updateListObjectEvent:new(type, modName, objectId, newValue));
		end;
	end;
end;